Loading...
Searching...
No Matches
Resource List Routines
APR Utility Functions
Collaboration diagram for Resource List Routines:

## Macros

#define | APR_RESLIST_CLEANUP_DEFAULT 0
#define | APR_RESLIST_CLEANUP_FIRST 1

## Typedefs

typedef struct apr_reslist_t | apr_reslist_t
typedef apr_status_t(* | apr_reslist_constructor) (void **resource, void *params, apr_pool_t *pool)
typedef apr_status_t(* | apr_reslist_destructor) (void *resource, void *params, apr_pool_t *pool)

## Functions

apr_status_t | apr_reslist_create (apr_reslist_t **reslist, int min, int smax, int hmax, apr_interval_time_t ttl, apr_reslist_constructor con, apr_reslist_destructor de, void *params, apr_pool_t *pool)
apr_status_t | apr_reslist_destroy (apr_reslist_t *reslist)
apr_status_t | apr_reslist_acquire (apr_reslist_t *reslist, void **resource)
apr_status_t | apr_reslist_release (apr_reslist_t *reslist, void *resource)
void | apr_reslist_timeout_set (apr_reslist_t *reslist, apr_interval_time_t timeout)
apr_uint32_t | apr_reslist_acquired_count (apr_reslist_t *reslist)
apr_status_t | apr_reslist_invalidate (apr_reslist_t *reslist, void *resource)
apr_status_t | apr_reslist_maintain (apr_reslist_t *reslist)
void | apr_reslist_cleanup_order_set (apr_reslist_t *reslist, apr_uint32_t mode)

## Detailed Description

## Macro Definition Documentation

## APR_RESLIST_CLEANUP_DEFAULT

#define APR_RESLIST_CLEANUP_DEFAULT 0

default pool cleanup

## APR_RESLIST_CLEANUP_FIRST

#define APR_RESLIST_CLEANUP_FIRST 1

use pool pre cleanup

## Typedef Documentation

## apr_reslist_t

typedef struct apr_reslist_t apr_reslist_t

Opaque resource list object

## Function Documentation

## apr_reslist_acquire()

apr_status_t apr_reslist_acquire | ( | apr_reslist_t * | reslist,
|  | void ** | resource )

Retrieve a resource from the list, creating a new one if necessary. If we have met our maximum number of resources, we will block until one becomes available.

Parameters

  reslist | The resource list.
  resource | An address where the pointer to the resource will be stored.

## apr_reslist_acquired_count()

apr_uint32_t apr_reslist_acquired_count | ( | apr_reslist_t * | reslist | ) |

Return the number of outstanding resources.

Parameters

  reslist | The resource list.

## apr_reslist_cleanup_order_set()

void apr_reslist_cleanup_order_set | ( | apr_reslist_t * | reslist,
|  | apr_uint32_t | mode )

Set reslist cleanup order.

Parameters

  reslist | The resource list.

  mode

  Cleanup order mode

                APR_RESLIST_CLEANUP_DEFAULT  default pool cleanup order
                APR_RESLIST_CLEANUP_FIRST    use pool pre cleanup

Remarks
  If APR_RESLIST_CLEANUP_FIRST is used the destructors will be called before child pools of the pool used to create the reslist are destroyed. This allows to explicitly destroy the child pools inside reslist destructors.

## apr_reslist_create()

apr_status_t apr_reslist_create | ( | apr_reslist_t ** | reslist,
|  | int | min,
|  | int | smax,
|  | int | hmax,
|  | apr_interval_time_t | ttl,
|  | apr_reslist_constructor | con,
|  | apr_reslist_destructor | de,
|  | void * | params,
|  | apr_pool_t * | pool )

Create a new resource list with the following parameters:

Parameters

  reslist | An address where the pointer to the new resource list will be stored.
  min | Allowed minimum number of available resources. Zero creates new resources only when needed.
  smax | Resources will be destroyed during reslist maintenance to meet this maximum restriction as they expire (reach their ttl).
  hmax | Absolute maximum limit on the number of total resources.
  ttl | If non-zero, sets the maximum amount of time in microseconds an unused resource is valid. Any resource which has exceeded this time will be destroyed, either when encountered by apr_reslist_acquire() or during reslist maintenance.
  con | Constructor routine that is called to create a new resource.
  de | Destructor routine that is called to destroy an expired resource.
  params | Passed to constructor and deconstructor
  pool | The pool from which to create this resource list. Also the same pool that is passed to the constructor and destructor routines.

Remarks
  If APR has been compiled without thread support, hmax will be automatically set to 1 and values of min and smax will be forced to 1 for any non-zero value.

## apr_reslist_destroy()

apr_status_t apr_reslist_destroy | ( | apr_reslist_t * | reslist | ) |

Destroy the given resource list and all resources controlled by this list. FIXME: Should this block until all resources become available, or maybe just destroy all the free ones, or maybe destroy them even though they might be in use by something else? Currently it will abort if there are resources that haven't been released, so there is an assumption that all resources have been released to the list before calling this function.

Parameters

  reslist | The reslist to destroy

## apr_reslist_invalidate()

apr_status_t apr_reslist_invalidate | ( | apr_reslist_t * | reslist,
|  | void * | resource )

Invalidate a resource in the pool - e.g. a database connection that returns a "lost connection" error and can't be restored. Use this instead of apr_reslist_release if the resource is bad.

Parameters

  reslist | The resource list.
  resource | The resource to invalidate.

## apr_reslist_maintain()

apr_status_t apr_reslist_maintain | ( | apr_reslist_t * | reslist | ) |

Perform routine maintenance on the resource list. This call may instantiate new resources or expire old resources.

Parameters

  reslist | The resource list.

## apr_reslist_release()

apr_status_t apr_reslist_release | ( | apr_reslist_t * | reslist,
|  | void * | resource )

Return a resource back to the list of available resources.

Parameters

  reslist | The resource list.
  resource | The resource to return to the list.

## apr_reslist_timeout_set()

void apr_reslist_timeout_set | ( | apr_reslist_t * | reslist,
|  | apr_interval_time_t | timeout )

Set the timeout the acquire will wait for a free resource when the maximum number of resources is exceeded.

Parameters

  reslist | The resource list.
  timeout | Timeout to wait. The zero waits forever.